%{
/* expr.LL:  L-file for a simple expression language */
#include "parser.hh"
%}

%% 
[ \n\t\f]*     ;  
[0-9]+         return(CONST); @{
                  {long val;
                   sscanf(yytext,"%ld",&val); @CONST.val@ = val;
#if defined(MODLEAF_TREEOUT) || defined(MODNODE_TREEOUT)
                   {char leaf_label[20];
                    snprintf(leaf_label,sizeof(leaf_label),"CONST|%ld",val);
                    agset(@CONST.NIO@,(char *)"label",leaf_label);}
#endif
                  }
               @}
\(             return('('); 
\)             return(')'); 
\+             return('+'); 
\*             return('*'); 
%%
int yywrap(void){return 1;}
