#if defined (__cplusplus)
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <cctype>
#else
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#endif

#include "parser.h"
#include "semtypes.h"

#define bufsize 80
char buf[bufsize];
char *lexBuf;

char *lexeme(char inString[])
  {return strcpy((char *)malloc(1+strlen(inString)),inString);}

int yylex()
  {char *bufp = buf;

   while ((*bufp = getchar()) != EOF) 
     {if (bufp == (buf + bufsize - 1))
         {fprintf(stderr,"exceeded buffer\n"); exit(-1);}
      if ((*bufp == ' ')  || (*bufp == '\n') || 
          (*bufp == '\t') || (*bufp == '\f')
         )
         {if (bufp == buf) continue; else break;}
      if (!isalnum(*bufp)) {fprintf(stderr,"illegal character\n"); exit(-1);}
      bufp++; 
     } 
   if (bufp != buf) 
      {*++bufp = '\0'; 
       lexBuf = lexeme(buf);
       bufp = lexBuf;

#include "lexer.l"

      }
   return 0;
  }
