%{
#if defined (__cplusplus)
#include <cstdlib>
#include <cstring>
#else
#include <stdlib.h>
#include <string.h>
#endif

#include "parser.h"

#define lexeme strcpy((char *)malloc(yyleng+1),yytext)
%}

%% 
[ \n\t\f]+        ;  
[0-9]+            return(ICONST); @{ @ICONST.string@ = lexeme; @} 
"("               return('('); 
")"               return(')'); 
"*"               return('*'); 
"/"               return('/'); 
"+"               return('+'); 
"-"               return('-'); 
%%
int yywrap(void){return 1;}
