#include <cstdbool>

struct enumList;
struct typeSpec;
struct symbolTableItem {
    char            *sym;
    bool             isConstVal;
    int              constVal;
    bool             isEnumLit;
    struct enumList *whichEnum;
    bool             isTypeName;
    struct typeSpec *whichType;
};
typedef struct symbolTableItem *symbolP;
typedef struct symbolTableItem *symTable;

struct enumList {
    symbolP          enumLit;
    int              constVal;
    struct enumList *next;
};
typedef struct enumList *enumListP;

struct subRange {
    int              start;
    int              end;
};
typedef struct subRange *subRangeP;

enum typeSpecTag {enumT, rangeT};
struct typeSpec {
    enum typeSpecTag tag;
    union {
        struct enumList enumType;
        struct subRange rangeType;
    }           type;
};
typedef struct typeSpec *typeSpecP;
