/* ANSI-C code produced by gperf version 3.1 */
/* Command-line: gperf --multiple-iterations=2 --jump=0 --no-strlen --random --output-file=yox-directives.cc yox-directives.gperf  */
/* Computed positions: -k'2,5-9' */

#if !((' ' == 32) && ('!' == 33) && ('"' == 34) && ('#' == 35) \
      && ('%' == 37) && ('&' == 38) && ('\'' == 39) && ('(' == 40) \
      && (')' == 41) && ('*' == 42) && ('+' == 43) && (',' == 44) \
      && ('-' == 45) && ('.' == 46) && ('/' == 47) && ('0' == 48) \
      && ('1' == 49) && ('2' == 50) && ('3' == 51) && ('4' == 52) \
      && ('5' == 53) && ('6' == 54) && ('7' == 55) && ('8' == 56) \
      && ('9' == 57) && (':' == 58) && (';' == 59) && ('<' == 60) \
      && ('=' == 61) && ('>' == 62) && ('?' == 63) && ('A' == 65) \
      && ('B' == 66) && ('C' == 67) && ('D' == 68) && ('E' == 69) \
      && ('F' == 70) && ('G' == 71) && ('H' == 72) && ('I' == 73) \
      && ('J' == 74) && ('K' == 75) && ('L' == 76) && ('M' == 77) \
      && ('N' == 78) && ('O' == 79) && ('P' == 80) && ('Q' == 81) \
      && ('R' == 82) && ('S' == 83) && ('T' == 84) && ('U' == 85) \
      && ('V' == 86) && ('W' == 87) && ('X' == 88) && ('Y' == 89) \
      && ('Z' == 90) && ('[' == 91) && ('\\' == 92) && (']' == 93) \
      && ('^' == 94) && ('_' == 95) && ('a' == 97) && ('b' == 98) \
      && ('c' == 99) && ('d' == 100) && ('e' == 101) && ('f' == 102) \
      && ('g' == 103) && ('h' == 104) && ('i' == 105) && ('j' == 106) \
      && ('k' == 107) && ('l' == 108) && ('m' == 109) && ('n' == 110) \
      && ('o' == 111) && ('p' == 112) && ('q' == 113) && ('r' == 114) \
      && ('s' == 115) && ('t' == 116) && ('u' == 117) && ('v' == 118) \
      && ('w' == 119) && ('x' == 120) && ('y' == 121) && ('z' == 122) \
      && ('{' == 123) && ('|' == 124) && ('}' == 125) && ('~' == 126))
/* The character set is not based on ISO-646.  */
#error "gperf generated tables don't work with this execution character set. Please report a bug to <bug-gperf@gnu.org>."
#endif

#line 15 "yox-directives.gperf"

/* $Id: yox-directives.gperf 2379 2022-01-07 22:41:51Z teshields $ */

/* This file is part of Ox, an Attribute Grammar Compiling System
   that augments the specification functionality of Lex and Yacc, and
   input specification compatible lexer and parser generators.

   Copyright (C) 2020-2022  Thomas E. Shields

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#include "yox-directives.hh"
#include <cstring>
#include <string.h>
enum
  {
    TOTAL_KEYWORDS = 58,
    MIN_WORD_LENGTH = 2,
    MAX_WORD_LENGTH = 15,
    MIN_HASH_VALUE = 1,
    MAX_HASH_VALUE = 81
  };

/* maximum key range = 81, duplicates = 0 */

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
static unsigned int
yox_directive_hash (register const char *str, register size_t len)
{
  static const unsigned char asso_values[] =
    {
      82, 82, 82, 82, 82, 82, 82, 82, 82, 82,
      82, 82, 82, 82, 82, 82, 82, 82, 82, 82,
      82, 82, 82, 82, 82, 82, 82, 82, 82, 82,
      82, 82, 82, 82, 82, 82, 82, 82, 82, 82,
      82, 82, 82, 82, 82, 27, 82, 82, 19, 82,
      12, 82, 82, 82, 82, 82, 82, 82, 82, 82,
       4, 82,  3, 82,  1, 82, 82, 82, 82, 82,
      82, 82, 82, 82, 82, 82, 82, 82, 82, 82,
      82, 82, 82, 82, 82, 82, 82, 82, 82, 82,
      82, 82, 82, 82, 82,  6, 82,  2, 18, 20,
      26,  1, 11,  8, 52,  2, 82, 82, 11, 36,
       1,  2,  3, 82,  1, 13,  4, 26, 15,  1,
      82, 37, 82, 82, 82, 82, 82, 82
    };
  register unsigned int hval = 0;

  switch (len)
    {
      default:
        hval += asso_values[(unsigned char)str[8]];
      /*FALLTHROUGH*/
      case 8:
        hval += asso_values[(unsigned char)str[7]];
      /*FALLTHROUGH*/
      case 7:
        hval += asso_values[(unsigned char)str[6]];
      /*FALLTHROUGH*/
      case 6:
        hval += asso_values[(unsigned char)str[5]];
      /*FALLTHROUGH*/
      case 5:
        hval += asso_values[(unsigned char)str[4]];
      /*FALLTHROUGH*/
      case 4:
      case 3:
      case 2:
        hval += asso_values[(unsigned char)str[1]];
        break;
    }
  return hval;
}

static const unsigned char lengthtable[] =
  {
     0,  2,  5,  2,  2,  5,  6,  6,  7,  7,  8,  3,  2, 12,
     9,  5, 12,  8,  6,  2,  0,  5,  9,  5,  6, 10,  7, 15,
    12,  6,  7,  8,  9, 10, 12,  7, 10, 12,  6,  6,  5,  6,
     6,  8, 12,  6, 10,  6, 15, 12,  0,  9, 11, 11, 10,  8,
     9,  6,  7,  8,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 11
  };

static const yox_directive wordlist[] =
  {
    {(char*)0,AGC::parser::token::YYEMPTY,other},
#line 127 "yox-directives.gperf"
    {"%@",              AGC::parser::token::LOCATION,      other},
#line 144 "yox-directives.gperf"
    {"@warn",           AGC::parser::token::OX_WARN,       other},
#line 49 "yox-directives.gperf"
    {"%>",              AGC::parser::token::RIGHT,         other},
#line 47 "yox-directives.gperf"
    {"%<",              AGC::parser::token::LEFT,          other},
#line 56 "yox-directives.gperf"
    {"%type",           AGC::parser::token::TYPE,          other},
#line 54 "yox-directives.gperf"
    {"%token",          AGC::parser::token::TOKEN,         other},
#line 94 "yox-directives.gperf"
    {"%ident",          AGC::parser::token::YYEMPTY,       C_string},
#line 131 "yox-directives.gperf"
    {"%export",         AGC::parser::token::EXPORT,        other},
#line 132 "yox-directives.gperf"
    {"%import",         AGC::parser::token::IMPORT,        other},
#line 70 "yox-directives.gperf"
    {"%printer",        AGC::parser::token::PRINTER,       other},
#line 138 "yox-directives.gperf"
    {"%la",             AGC::parser::token::LOOKAHEAD,     other},
#line 52 "yox-directives.gperf"
    {"%2",              AGC::parser::token::NONASSOC,      other},
#line 87 "yox-directives.gperf"
    {"%name_prefix",    AGC::parser::token::NAME_PREFIX,   C_string},
#line 126 "yox-directives.gperf"
    {"%position",       AGC::parser::token::LOCATION,      other},
#line 46 "yox-directives.gperf"
    {"%left",           AGC::parser::token::LEFT,          other},
#line 105 "yox-directives.gperf"
    {"%pure_parser",    AGC::parser::token::PURE_PARSER,   other},
#line 134 "yox-directives.gperf"
    {"%scanner",        AGC::parser::token::SCANNER,       other},
#line 57 "yox-directives.gperf"
    {"%start",          AGC::parser::token::START,         other},
#line 55 "yox-directives.gperf"
    {"%0",              AGC::parser::token::TOKEN,         other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
#line 98 "yox-directives.gperf"
    {"%code",           AGC::parser::token::CODE,          other},
#line 125 "yox-directives.gperf"
    {"%location",       AGC::parser::token::LOCATION,      other},
#line 62 "yox-directives.gperf"
    {"%prec", AGC::parser::token::PREC, other},
#line 133 "yox-directives.gperf"
    {"%local",          AGC::parser::token::LOCAL,         other},
#line 101 "yox-directives.gperf"
    {"%lex_param",      AGC::parser::token::LEX_PARAM,     other},
#line 111 "yox-directives.gperf"
    {"%expect",         AGC::parser::token::EXPECT,        C_int},
#line 99 "yox-directives.gperf"
    {"%initial_action", AGC::parser::token::CODE,          other},
#line 103 "yox-directives.gperf"
    {"%parse_param",    AGC::parser::token::PARSE_PARAM,   other},
#line 58 "yox-directives.gperf"
    {"%union",          AGC::parser::token::UNION,         other},
#line 66 "yox-directives.gperf"
    {"%define",         AGC::parser::token::DEFINE,        other},
#line 89 "yox-directives.gperf"
    {"%require",        AGC::parser::token::YYEMPTY,       C_string},
#line 90 "yox-directives.gperf"
    {"%skeleton",       AGC::parser::token::SKELETON,      C_string},
#line 117 "yox-directives.gperf"
    {"%expect_rr",      AGC::parser::token::EXPECT_RR,     C_int},
#line 86 "yox-directives.gperf"
    {"%name-prefix",    AGC::parser::token::NAME_PREFIX,   C_string},
#line 88 "yox-directives.gperf"
    {"%output",         AGC::parser::token::YYEMPTY,       C_string},
#line 147 "yox-directives.gperf"
    {"@traversal",      AGC::parser::token::OX_TRAV,       other},
#line 106 "yox-directives.gperf"
    {"%pure-parser",    AGC::parser::token::PURE_PARSER,   other},
#line 67 "yox-directives.gperf"
    {"%nterm",          AGC::parser::token::NTERM,         other},
#line 146 "yox-directives.gperf"
    {"@macro",          AGC::parser::token::OX_MACRO,      other},
#line 53 "yox-directives.gperf"
    {"%term",           AGC::parser::token::TOKEN,         other},
#line 68 "yox-directives.gperf"
    {"%param",          AGC::parser::token::PARAM,         other},
#line 75 "yox-directives.gperf"
    {"%empty",          AGC::parser::token::EMPTY,         other},
#line 80 "yox-directives.gperf"
    {"%defines",        AGC::parser::token::YYEMPTY,       C_string},
#line 84 "yox-directives.gperf"
    {"%file-prefix",    AGC::parser::token::YYEMPTY,       C_string},
#line 76 "yox-directives.gperf"
    {"%merge",          AGC::parser::token::MERGE,         other},
#line 102 "yox-directives.gperf"
    {"%lex-param",      AGC::parser::token::LEX_PARAM,     other},
#line 74 "yox-directives.gperf"
    {"%dprec",          AGC::parser::token::DPREC,         other},
#line 100 "yox-directives.gperf"
    {"%initial-action", AGC::parser::token::CODE,          other},
#line 104 "yox-directives.gperf"
    {"%parse-param",    AGC::parser::token::PARSE_PARAM,   other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
#line 50 "yox-directives.gperf"
    {"%nonassoc",       AGC::parser::token::NONASSOC,      other},
#line 69 "yox-directives.gperf"
    {"%precedence",     AGC::parser::token::PRECEDENCE,    other},
#line 145 "yox-directives.gperf"
    {"@attributes",     AGC::parser::token::OX_ATTRIBUTES, other},
#line 116 "yox-directives.gperf"
    {"%expect-rr",      AGC::parser::token::EXPECT_RR,     C_int},
#line 142 "yox-directives.gperf"
    {"@autosyn",        AGC::parser::token::OX_AUTOSYN,    other},
#line 85 "yox-directives.gperf"
    {"%language",       AGC::parser::token::LANGUAGE,      C_string},
#line 48 "yox-directives.gperf"
    {"%right",          AGC::parser::token::RIGHT,         other},
#line 51 "yox-directives.gperf"
    {"%binary",         AGC::parser::token::NONASSOC,      other},
#line 143 "yox-directives.gperf"
    {"@autoinh",        AGC::parser::token::OX_AUTOINH,    other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
    {(char*)0,AGC::parser::token::YYEMPTY,other},
#line 121 "yox-directives.gperf"
    {"%destructor",     AGC::parser::token::DESTRUCTOR,    other}
  };

const yox_directive *
in_yox_directive_set (register const char *str, register size_t len)
{
  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register unsigned int key = yox_directive_hash (str, len);

      if (key <= MAX_HASH_VALUE)
        if (len == lengthtable[key])
          {
            register const char *s = wordlist[key].name;

            if (s && *str == *s && !memcmp (str + 1, s + 1, len - 1))
              return &wordlist[key];
          }
    }
  return 0;
}
