/* $Id: util.h 728 2018-01-21 05:29:22Z Tom Shields $ */ 

extern int yyyinput(void);

#if YYBTYACC && !YYBYACC
extern void yyerror(const char *, ...);
#else
extern void yyerror(const char *);
#endif
extern void fatal(const char *);
extern void internal(const char *); 
extern void handleOverflow(const char *);
extern FILE *safeOpen(const char *,const char *);
extern void printStringArray(const char **,int,FILE *); 

